#version 300 es

#define Pi 3.14159265359

layout( location = 0 ) in vec3 attrib_pos;

layout(std140) uniform glfx_GLOBAL
{
	mat4 glfx_MVP;
	mat4 glfx_PROJ;
	mat4 glfx_MV;
	vec4 glfx_VIEW_QUAT;
};

layout(std140) uniform glfx_BASIS_DATA
{
	vec4 unused;
	vec4 glfx_SCREEN;
	vec4 glfx_BG_MASK_T[2];
	vec4 glfx_HAIR_MASK_T[2];
	vec4 glfx_LIPS_MASK_T[2];
	vec4 glfx_L_EYE_MASK_T[2];
	vec4 glfx_R_EYE_MASK_T[2];
	vec4 glfx_SKIN_MASK_T[2];
	vec4 glfx_OCCLUSION_MASK_T[2];
};


out vec2 var_bgmask_uv;
out vec3 var_v;

vec3 quat_rotate( vec4 q, vec3 v )
{
	return v + 2.*cross( q.xyz, cross( q.xyz, v ) + q.w*v );
}

vec3 rotateAxis(vec3 p, vec3 axis, float angle)
{
	return mix(dot(axis, p)*axis, p, cos(angle)) + cross(axis,p)*sin(angle);
}

void main()
{
	vec2 v = attrib_pos.xy;
	gl_Position = vec4( v, 1., 1. );
	mat2x3 bg_basis = mat2x3(glfx_BG_MASK_T[0].xyz, glfx_BG_MASK_T[1].xyz);
	var_bgmask_uv = vec3(v,1.)*bg_basis;
	var_bgmask_uv.y += 0.5/256.;

	vec4 q = glfx_VIEW_QUAT;

	 q.x = -q.x;
     q.y = -q.y;

    vec3 side = quat_rotate( q, vec3(1.,0.,0.) );
    vec3 up = quat_rotate( q, vec3(0.,1.,0.) );

	vec3 vectorToRotate = vec3(v/vec2(glfx_PROJ[0][0],glfx_PROJ[1][1]),-1.);

	float angle = 0.;
	if( side.y > 0.7071 && glfx_SCREEN.x > glfx_SCREEN.y){
		angle = -Pi/2.;
	}
	else if( side.y < -0.7071 && glfx_SCREEN.x > glfx_SCREEN.y){
		angle = Pi/2.;
	}

	vectorToRotate = rotateAxis(vectorToRotate,vec3(0.,0.,1.),angle);

	vec4 q1 = glfx_VIEW_QUAT;

	var_v = quat_rotate( q1,vectorToRotate);
}
