#version 300 es

precision highp float;

in vec2 var_uv;

layout( location = 0 ) out vec4 F;

uniform sampler2D glfx_VIDEO;
uniform sampler2D glfx_BACKGROUND;

layout(std140) uniform glfx_BASIS_DATA
{
	vec4 unused;
	vec4 glfx_SCREEN;
	vec4 glfx_BG_MASK_T[2];
	vec4 glfx_HAIR_MASK_T[2];
	vec4 glfx_LIPS_MASK_T[2];
	vec4 glfx_L_EYE_MASK_T[2];
	vec4 glfx_R_EYE_MASK_T[2];
	vec4 glfx_SKIN_MASK_T[2];
	vec4 glfx_OCCLUSION_MASK_T[2];
};

vec2 aspect_fill_uv_tex(vec2 uv)
{
    vec2 textureSize = vec2(textureSize(glfx_VIDEO, 0));
    float aspect_ratio = glfx_SCREEN.y / glfx_SCREEN.x;
    float texture_aspect_ratio = textureSize.y / textureSize.x;
    float scale_x = 1.0;
    float scale_y = 1.0;
    if (texture_aspect_ratio > aspect_ratio) {
        scale_y = texture_aspect_ratio / aspect_ratio;
    } else {
        scale_x = aspect_ratio / texture_aspect_ratio;
    }
    
    float inv_scale_x = 1. / scale_x;
    float inv_scale_y = 1. / scale_y;
    
    return vec2(mat3(inv_scale_x, 0., 0., 0., inv_scale_y, 0., 0.5, 0.5, 1.0) * vec3(uv - 0.5, 1.));
}

void main()
{   
    vec2 uv = var_uv;
    vec3 bg = texture(glfx_BACKGROUND, uv ).xyz;
    uv.y = 1. - uv.y;

    uv = aspect_fill_uv_tex(uv);
    vec4 bg_tex = texture(glfx_VIDEO, uv);

    F = vec4(bg_tex.xyz, 1.0);
}
